import java.util.*;
public class paper_evan
{
	static char[] s;
	static ArrayList<Element> elements;
	static int n;
	static int[][][][][] memo;
	
	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);
		
		String input = in.next();
		
		StringBuilder builder = new StringBuilder();
		elements = new ArrayList<Element>();
		for(int i = 0; i < input.length(); i++)
		{
			if(i == 0 || input.charAt(i) != input.charAt(i - 1))
			{
				builder.append(input.charAt(i));
				elements.add(new Element(elements.size()));
			}
		}
		s = builder.toString().toCharArray();
		Collections.sort(elements);
		
		n = s.length;
		
		if(n == 1)
		{
			System.out.println(0);
			return;
		}
		
		memo = new int[n - 1][3][3][n + 1][n + 1];
		for(int[][][][] a : memo)
		{
			for(int[][][] b : a)
			{
				for(int[][] c : b)
				{
					for(int[] d : c)
					{
						Arrays.fill(d, -1);
					}
				}
			}
		}
		
		System.out.println(n - 1 - dp(0, 0, 0, n, n));
	}
	
	static int dp(int index, int leftFlag, int rightFlag, int leftIndex, int rightIndex)
	{
		if(index == n - 1)
		{
			return 0;
		}
		else if(leftIndex == rightIndex && leftIndex != n && !(leftIndex == elements.get(n - 1).index && s[elements.get(n - 2).index] != s[leftIndex]))
		{
			return Integer.MIN_VALUE;
		}
		else if(memo[index][leftFlag][rightFlag][leftIndex][rightIndex] != -1)
		{
			return memo[index][leftFlag][rightFlag][leftIndex][rightIndex];
		}
		else if(index > 0 && (leftFlag != 0 || rightFlag != 0) && s[elements.get(index).index] > s[elements.get(index - 1).index])
		{
			return memo[index][leftFlag][rightFlag][leftIndex][rightIndex] = dp(index, 0, 0, leftIndex, rightIndex);
		}
		
		int current = elements.get(index).index;
		int ret = Integer.MIN_VALUE;
		
		if(leftFlag != 2 && (canExtend(current, leftIndex) || s[leftIndex - 1] == s[current]))
		{
			ret = Math.max(ret, dp(index + 1, 1, rightFlag, leftIndex, rightIndex));
		}
		
		if(rightFlag != 2 && (canExtend(current, rightIndex) || s[rightIndex + 1] == s[current]))
		{
			ret = Math.max(ret, dp(index + 1, leftFlag, 1, leftIndex, rightIndex));
		}
		
		if(canExtend(current, leftIndex) && current < n - 1 && s[current + 1] > s[current] && (current != leftIndex || leftFlag == 0))
		{
			int nextFlag = current != leftIndex ? leftFlag : 2;
			ret = Math.max(ret, 1 + dp(index + 1, nextFlag, rightFlag, current + 1, rightIndex));
		}
		
		if(canExtend(current, rightIndex) && current > 0 && s[current - 1] > s[current] && (current != rightIndex || rightFlag == 0))
		{
			int nextFlag = current != rightIndex ? rightFlag : 2;
			ret = Math.max(ret, 1 + dp(index + 1, leftFlag, nextFlag, leftIndex, current - 1));
		}
		
		return memo[index][leftFlag][rightFlag][leftIndex][rightIndex] = ret;
	}
	
	static boolean canExtend(int current, int topIndex)
	{
		return topIndex == n || s[topIndex] <= s[current];
	}
	
	static class Element implements Comparable<Element>
	{
		int index;
		
		public Element(int i)
		{
			index = i;
		}
		
		public int compareTo(Element o)
		{
			return s[index] - s[o.index];
		}
	}
}
